ParallelCompositeReader (Lucene 10.5.0 core API)
Description: declaration: package: org.apache.lucene.index, class: ParallelCompositeReader

Package org.apache.lucene.index

# Class ParallelCompositeReader

java.lang.Object
org.apache.lucene.index.IndexReader
org.apache.lucene.index.CompositeReader
org.apache.lucene.index.BaseCompositeReader<LeafReader>
org.apache.lucene.index.ParallelCompositeReader

All Implemented Interfaces:
  `Closeable`, `AutoCloseable`

public class ParallelCompositeReader extends BaseCompositeReader<LeafReader>
An `CompositeReader` which reads multiple, parallel indexes. Each index added must have the same number of documents, and exactly the same number of leaves (with equal `maxDoc`), but typically each contains different fields. Deletions are taken from the first reader. Each document contains the union of the fields of all documents with the same document number. When searching, matches for a query term are from the first index added that has the field.

This is useful, e.g., with collections that have large fields which change rarely and small fields that change more frequently. The smaller fields may be re-indexed in a new index and both indexes may be searched together.

Warning: It is up to you to make sure all indexes are created and modified the same way. For example, if you add documents to one index, you need to add the same documents in the same order to the other indexes. Failure to do so will result in undefined behavior. A good strategy to create suitable indexes with `IndexWriter` is to use `LogDocMergePolicy`, as this one does not reorder documents during merging (like `TieredMergePolicy`) and triggers merges by number of documents per segment. If you use different `MergePolicy`s it might happen that the segment structure of your index is no longer predictable.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class org.apache.lucene.index.IndexReader

  `IndexReader.CacheHelper, IndexReader.CacheKey, IndexReader.ClosedListener`

- ## Field Summary

  ### Fields inherited from class org.apache.lucene.index.BaseCompositeReader

  `subReadersSorter`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ParallelCompositeReader(boolean closeSubReaders, CompositeReader... readers)`
  Create a ParallelCompositeReader based on the provided readers.
  `ParallelCompositeReader(boolean closeSubReaders, CompositeReader[] readers, CompositeReader[] storedFieldReaders)`
  Expert: create a ParallelCompositeReader based on the provided readers and storedFieldReaders; when a document is loaded, only storedFieldsReaders will be used.
  `ParallelCompositeReader(CompositeReader... readers)`
  Create a ParallelCompositeReader based on the provided readers; auto-closes the given readers on `IndexReader.close()`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected void`
  `doClose()`
  Implements close.
  `IndexReader.CacheHelper`
  `getReaderCacheHelper()`
  Optional method: Return a `IndexReader.CacheHelper` that can be used to cache based on the content of this reader.

  ### Methods inherited from class org.apache.lucene.index.BaseCompositeReader

  `docFreq, getDocCount, getSequentialSubReaders, getSumDocFreq, getSumTotalTermFreq, maxDoc, numDocs, readerBase, readerIndex, storedFields, termVectors, totalTermFreq`

  ### Methods inherited from class org.apache.lucene.index.CompositeReader

  `getContext, toString`

  ### Methods inherited from class org.apache.lucene.index.IndexReader

  `close, decRef, ensureOpen, equals, getRefCount, hasDeletions, hashCode, incRef, leaves, notifyReaderClosedListeners, numDeletedDocs, registerParentReader, tryIncRef`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### ParallelCompositeReader

    public ParallelCompositeReader(CompositeReader... readers) throws IOException
    Create a ParallelCompositeReader based on the provided readers; auto-closes the given readers on `IndexReader.close()`.
    Throws:
      `IOException`

  - ### ParallelCompositeReader

    public ParallelCompositeReader(boolean closeSubReaders, CompositeReader... readers) throws IOException
    Create a ParallelCompositeReader based on the provided readers.
    Throws:
      `IOException`

  - ### ParallelCompositeReader

    public ParallelCompositeReader(boolean closeSubReaders, CompositeReader[] readers, CompositeReader[] storedFieldReaders) throws IOException
    Expert: create a ParallelCompositeReader based on the provided readers and storedFieldReaders; when a document is loaded, only storedFieldsReaders will be used.
    Throws:
      `IOException`

- ## Method Details

  - ### getReaderCacheHelper

    public IndexReader.CacheHelper getReaderCacheHelper()
    Description copied from class: `IndexReader`
    Optional method: Return a `IndexReader.CacheHelper` that can be used to cache based on the content of this reader. Two readers that have different data or different sets of deleted documents will be considered different.

    A return value of `null` indicates that this reader is not suited for caching, which is typically the case for short-lived wrappers that alter the content of the wrapped reader.

    Specified by:
      `getReaderCacheHelper` in class `IndexReader`

  - ### doClose

    protected void doClose() throws IOException
    Description copied from class: `IndexReader`
    Implements close.
    Specified by:
      `doClose` in class `IndexReader`
    Throws:
      `IOException`